
function ModalDiv(obj, name)
{
    obj.name = name;
	obj.position = "center";
    obj.onShow = function(){
        return true;
    };
    obj.onHide = function(){
        return true;
    };
    obj.onShowAfter = function(){};
    obj.onHideAfter = function(){};
    obj.show = function show()
    {
        if (obj.onShow())
        {
            ModalDiv.show(name);
			ModalDiv.positioning(name);
            obj.onShowAfter();
        }
    };
    obj.hide = function hide()
    {
        if (obj.onHide())
        {
            ModalDiv.hide(name);
            obj.onHideAfter();
        }
    }
	obj.getPosition = function()
	{
		return obj.position;
	}
}

ModalDiv._static = {};
ModalDiv._static.splashs = {};

ModalDiv.init = function(id, className, coreClassName)
{
    if(className.length > 0) className = className + " ";
	if(coreClassName.length > 0) coreClassName = " " + coreClassName;
	var el = jQuery("#" + id);
    if(!el.get().length > 0) return;
    if(el.data("_inited")) return;
	el.data({"_inited": "true"});
	el.detach();
    jQuery("<div/>").attr({'class': className + 'modalOuter' + coreClassName, 'id': id + 'Outer'}).css({'display': 'none'}).appendTo(jQuery("body")).append(el);
	el.css({"display": 'block'});
	ModalDiv._static.splashs[id] = new Splash({"class": coreClassName});
};

ModalDiv.show = function(id)
{
    if(!jQuery("#" + id).data("_inited")) ModalDiv.init(id);
	var splash = ModalDiv._static.splashs[id];
	splash.append().show();
    jQuery("#" + id + 'Outer').css({"display": 'block', "z-index": ++JCore._static.zIndex})
	splash = null;
};

ModalDiv.hide = function(id)
{
    jQuery("#" + id + 'Outer').css("display", 'none');
    var splash = ModalDiv._static.splashs[id];
	splash.hide();
	splash = null;
};

ModalDiv.positioning = function(id)
{
    var obj = window[id];
	if(obj == null) return;
	var pos = obj.getPosition();
	var el = jQuery('#' + id);
	if(typeof pos == "string" && pos == "center")
	{
		var top = (jQuery(window).height() - el.height()) / 2;
		el.css({"margin-top": top});
	}
	el = null;
	obj = null;
};

ModalDiv._static.destroy = function()
{
	//console.log("ModalDiv:")
	for(var key in ModalDiv._static.splashs)
	{
		var splash = ModalDiv._static.splashs[key];
		if(!splash) continue;
		splash.destroy();
	}
	ModalDiv._static.splashs = null;
};

/**
 * Вешаем обработчик для уничтожения фона
 */
(
	function()
	{
		jQuery(window).unload(function(){
			if(typeof ModalDiv != 'undefined') ModalDiv._static.destroy();
		});
	}
)();